Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/InlineElements/inline-elements.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/InlineElements/inline-elements.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/InlineElements/inline-elements.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2007-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2007-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -63,7 +63,7 @@
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "1.1",
+			version		: "2.0",
 			developer	: "Stanislas Rolland",
 			developerUrl	: "http://www.sjbr.ca/",
 			copyrightOwner	: "Stanislas Rolland",
@@ -80,9 +80,8 @@
 		var dropDownConfiguration = {
 			id		: buttonId,
 			tooltip		: this.localize(buttonId + "-Tooltip"),
-			options		: (this.editorConfiguration.buttons[buttonId.toLowerCase()]?this.editorConfiguration.buttons[buttonId.toLowerCase()]["dropDownOptions"]:null),
-			action		: "onChange",
-			refresh		: null
+			options		: (this.editorConfiguration.buttons[buttonId.toLowerCase()] ? this.editorConfiguration.buttons[buttonId.toLowerCase()].data : null),
+			action		: "onChange"
 		};
 		this.registerDropDown(dropDownConfiguration);
 		
@@ -193,7 +192,6 @@
 			// Could be a button or its hotkey
 		var buttonId = this.translateHotKey(id);
 		buttonId = buttonId ? buttonId : id;
-		var obj = editor._toolbarObjects[buttonId];
 		var element = this.convertBtn[buttonId];
 		if (element) {
 			this.applyInlineElement(editor, element);
@@ -206,9 +204,8 @@
 	/*
 	 * This function gets called when some inline element was selected in the drop-down list
 	 */
-	onChange : function (editor, buttonId) {
-		var tbobj = editor._toolbarObjects[buttonId];
-		var element = document.getElementById(tbobj.elementId).value;
+	onChange : function (editor, combo, record, index) {
+		var element = combo.getValue();
 		this.applyInlineElement(editor, element, false);
 	},
 	
@@ -235,7 +232,7 @@
 			}
 		}
 		if (!selectionEmpty) {
-			var statusBarSelection = (editor.getPluginInstance("StatusBar") ? editor.getPluginInstance("StatusBar").getSelection() : null);
+			var statusBarSelection = (editor.statusBar ? editor.statusBar.getSelection() : null);
 				// The selection is not empty.
 			for (var i = 0; i < ancestors.length; ++i) {
 				fullNodeSelected = (HTMLArea.is_ie && ((selection.type !== "Control" && ancestors[i].innerText === range.text) || (selection.type === "Control" && ancestors[i].innerText === range.item(0).text)))
@@ -374,22 +371,19 @@
 	/*
 	* This function gets called when the toolbar is updated
 	*/
-	onUpdateToolbar : function () {
+	onUpdateToolbar : function (button, mode, selectionEmpty, ancestors, endPointsInSameBlock) {
 		var editor = this.editor;
-		if (this.getEditorMode() === "wysiwyg" && editor.isEditable()) {
-			var id, activeButton;
-			var tagName = false, endPointsInSameBlock = true, fullNodeSelected = false;
+		if (mode === "wysiwyg" && editor.isEditable()) {
+			var tagName = false, fullNodeSelected = false;
 			var sel = editor._getSelection();
 			var range = editor._createRange(sel);
 			var parent = editor.getParentElement(sel);
 			if (parent && !HTMLArea.isBlockElement(parent)) {
 				tagName = parent.nodeName.toLowerCase();
 			}
-			var selectionEmpty = editor._selectionEmpty(sel);
 			if (!selectionEmpty) {
-				var statusBarSelection = editor.getPluginInstance("StatusBar") ? editor.getPluginInstance("StatusBar").getSelection() : null;
-				var ancestors = editor.getAllAncestors();
-				for (var i = 0; i < ancestors.length; ++i) {
+				var statusBarSelection = editor.statusBar ? editor.statusBar.getSelection() : null;
+				for (var i = 0, n = ancestors.length; i < n; ++i) {
 					fullNodeSelected = (statusBarSelection === ancestors[i])
 						&& ((HTMLArea.is_gecko && ancestors[i].textContent === range.toString()) || (HTMLArea.is_ie && ((sel.type !== "Control" && ancestors[i].innerText === range.text) || (sel.type === "Control" && ancestors[i].innerText === range.item(0).text))));
 					if (fullNodeSelected) {
@@ -406,31 +400,24 @@
 				}
 			}
 			var selectionInInlineElement = tagName && this.REInlineElements.test(tagName);
-			var disabled = !editor.endPointsInSameBlock() || (fullNodeSelected && !tagName) || (selectionEmpty && !selectionInInlineElement);
-			
-			var obj = editor.config.customSelects["FormatText"];
-			if ((typeof(obj) !== "undefined") && (typeof(editor._toolbarObjects[obj.id]) !== "undefined")) {
-				this.updateValue(editor, obj, tagName, selectionEmpty, fullNodeSelected, disabled);
-			}
-			
-			var ancestors = editor.getAllAncestors();
-			var bl = this.buttonList;
-			for (var i = 0; i < bl.length; ++i) {
-				var btn = bl[i];
-				id = btn[0];
-				var obj = editor._toolbarObjects[id];
-				if ((typeof(obj) !== "undefined")) {
-					activeButton = false;
-					for (var j = ancestors.length; --j >= 0;) {
-						var el = ancestors[j];
-						if (!el) { continue; }
-						if (this.convertBtn[id] === el.nodeName.toLowerCase()) {
+			var disabled = !endPointsInSameBlock || (fullNodeSelected && !tagName) || (selectionEmpty && !selectionInInlineElement);
+			switch (button.itemId) {
+				case 'FormatText':
+					this.updateValue(editor, button, tagName, selectionEmpty, fullNodeSelected, disabled);
+					break;
+				default:
+					var activeButton = false;
+					Ext.each(ancestors, function (ancestor) {
+						if (ancestor && this.convertBtn[button.itemId] === ancestor.nodeName.toLowerCase()) {
 							activeButton = true;
+							return false;
+						} else {
+							return true;
 						}
-					}
-					obj.state("active", activeButton);
-					obj.state("enabled", !disabled);
-				}
+					}, this);
+					button.setInactive(!activeButton);
+					button.setDisabled(disabled);
+					break;
 			}
 		}
 	},
@@ -438,31 +425,23 @@
 	/*
 	* This function updates the drop-down list of inline elemenents
 	*/
-	updateValue : function (editor, obj, tagName, selectionEmpty, fullNodeSelected, disabled) {
-		var select = document.getElementById(editor._toolbarObjects[obj.id]["elementId"]);
-		var options = select.options;
-		for (var i = options.length; --i >= 0;) {
-			options[i].selected = false;
+	updateValue: function (editor, select, tagName, selectionEmpty, fullNodeSelected, disabled) {
+		var store = select.getStore();
+		store.removeAt(0);
+		if ((store.findExact('value', tagName) != -1) && (selectionEmpty || fullNodeSelected)) {
+			select.setValue(tagName);
+			store.insert(0, new store.recordType({
+				text: this.localize('Remove markup'),
+				value: 'none'
+			}));
+		} else {
+			store.insert(0, new store.recordType({
+				text: this.localize('No markup'),
+				value: 'none'
+			}));
+			select.setValue('none');
 		}
-		select.selectedIndex = 0;
-		options[0].selected = true;
-		select.options[0].text = this.localize("No markup");
-		for (i = options.length; --i >= 0;) {
-			if (tagName === options[i].value) {
-				if (selectionEmpty || fullNodeSelected) {
-					options[i].selected = true;
-					select.selectedIndex = i;
-					select.options[0].text = this.localize("Remove markup");
-				}
-				break;
-			}
-		}
-		
-		select.disabled = !(options.length>1) || disabled;
-		select.className = "";
-		if (select.disabled) {
-			select.className = "buttonDisabled";
-		}
+		select.setDisabled(!(store.getCount()>1) || disabled);
 	}
 });
 
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/InsertSmiley/insert-smiley.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/InsertSmiley/insert-smiley.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/InsertSmiley/insert-smiley.js	(copie de travail)
@@ -2,7 +2,7 @@
 *  Copyright notice
 *
 *  (c) 2004 Ki Master George <kimastergeorge@gmail.com>
-*  (c) 2005-2009 Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
+*  (c) 2005-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -34,32 +34,31 @@
  */
 
 InsertSmiley = HTMLArea.Plugin.extend({
-
 	constructor : function(editor, pluginName) {
 		this.base(editor, pluginName);
 	},
-
 	/*
 	 * This function gets called by the class constructor
 	 */
 	configurePlugin : function(editor) {
-
 		this.pageTSConfiguration = this.editorConfiguration.buttons.emoticon;
-
+		this.editor_url = _typo3_host_url + _editor_url;
+		if (this.editor_url == '../') {
+			this.editor_url = document.URL.replace(/^(.*\/).*\/.*$/g, "$1");
+		}
 		/*
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "1.2",
+			version		: "2.0",
 			developer	: "Ki Master George & Stanislas Rolland",
-			developerUrl	: "http://www.fructifor.ca/",
+			developerUrl	: "http://www.sjbr.ca/",
 			copyrightOwner	: "Ki Master George & Stanislas Rolland",
-			sponsor		: "Ki Master George & Fructifor Inc.",
-			sponsorUrl	: "http://www.fructifor.ca/",
+			sponsor		: "Ki Master George & SJBR",
+			sponsorUrl	: "http://www.sjbr.ca/",
 			license		: "GPL"
 		};
 		this.registerPluginInformation(pluginInformation);
-
 		/*
 		 * Registering the button
 		 */
@@ -72,10 +71,8 @@
 			dialog		: true
 		};
 		this.registerButton(buttonConfiguration);
-
 		return true;
 	},
-
 	/*
 	 * This function gets called when the button was pressed.
 	 *
@@ -84,31 +81,77 @@
 	 *
 	 * @return	boolean		false if action is completed
 	 */
-	onButtonPress : function (editor, id) {
-
-		var sel = this.editor.getSelectedHTML().replace(/(<[^>]*>|&nbsp;|\n|\r)/g,"");
-		var param = new Object();
-		param.editor_url = _typo3_host_url + _editor_url;
-		if (param.editor_url == "../") {
-			param.editor_url = document.URL;
-			param.editor_url = param.editor_url.replace(/^(.*\/).*\/.*$/g, "$1");
+	onButtonPress: function (editor, id) {
+			// Could be a button or its hotkey
+		var buttonId = this.translateHotKey(id);
+		buttonId = buttonId ? buttonId : id;
+		var dimensions = this.getWindowDimensions({width:175, height:230}, buttonId);
+		this.dialog = new Ext.Window({
+			title: this.localize('Insert Smiley'),
+			cls: 'htmlarea-window',
+			border: false,
+			width: dimensions.width,
+			height: 'auto',
+			iconCls: buttonId,
+			listeners: {
+				close: {
+					fn: this.onClose,
+					scope: this
+				}
+			},
+			items: {
+				xtype: 'box',
+				cls: 'emoticon-array',
+				tpl: new Ext.XTemplate(
+					'<tpl for="."><a href="#" class="emoticon" hidefocus="on"><img alt="" title="" src="{.}" /></a></tpl>'
+				),
+				listeners: {
+					render: {
+						fn: this.render,
+						scope: this
+					}
+				}
+			},
+			buttons: [this.buildButtonConfig('Cancel', this.onCancel)]
+		});
+		this.show();
+	},
+	/*
+	 * Render the array of emoticon
+	 *
+	 * @param	object		component: the box containing the emoticons
+	 *
+	 * @return	void
+	 */
+	render: function (component) {
+		this.icons = [];
+		var numberOfIcons = 20, inum;
+		for (var i = 1; i <= numberOfIcons; i++) {
+			inum = i;
+			if (i < 10) {
+				inum = '000' + i;
+			} else if (i < 100) {
+				inum = '00' + i;
+			} else if (i < 1000) {
+				inum = '0' + i;
+			}
+			this.icons.push(this.editor_url + 'plugins/InsertSmiley/smileys/' + inum + '.gif');
 		}
-		this.dialog = this.openDialog("InsertSmiley", this.makeUrlFromPopupName("insertsmiley"), "insertImageTag", param, {width:250, height:230});
+		component.tpl.overwrite(component.el, this.icons);
+		component.mon(component.el, 'click', this.insertImageTag, this, {delegate: 'a'});
 	},
-
 	/*
-	 * Insert the selected smiley
+	 * Insert the selected emoticon
 	 *
-	 * @param	object		param: the selected smiley
+	 * @param	object		event: the Ext event
+	 * @param	HTMLelement	target: the html element target
 	 *
-	 * @return	boolean		false
+	 * @return	void
 	 */
-	insertImageTag : function (param) {
-		if (param && typeof(param.imgURL) != "undefined") {
-			this.editor.focusEditor();
-			this.editor.insertHTML('<img src="' + param.imgURL + '" alt="Smiley" />');
-		}
-		return false;
+	insertImageTag: function (event, target) {
+		this.editor.focus();
+		this.restoreSelection();
+		this.editor.insertHTML('<img src="' + Ext.get(target).first().getAttribute('src') + '" alt="" />');
+		this.close();
 	}
 });
-
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/Language/language.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/Language/language.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/Language/language.js	(copie de travail)
@@ -1,7 +1,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2008-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2008-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -52,14 +52,14 @@
 		}
 
 			// Importing list of allowed attributes
-		if (this.editor.getPluginInstance("TextStyle")) {
-			this.allowedAttributes = this.editor.getPluginInstance("TextStyle").allowedAttributes;
+		if (this.getPluginInstance("TextStyle")) {
+			this.allowedAttributes = this.getPluginInstance("TextStyle").allowedAttributes;
 		}			
-		if (!this.allowedAttributes && this.editor.getPluginInstance("InlineElements")) {
-			this.allowedAttributes = this.editor.getPluginInstance("InlineElements").allowedAttributes;
+		if (!this.allowedAttributes && this.getPluginInstance("InlineElements")) {
+			this.allowedAttributes = this.getPluginInstance("InlineElements").allowedAttributes;
 		}
-		if (!this.allowedAttributes && this.editor.getPluginInstance("BlockElements")) {
-			this.allowedAttributes = this.editor.getPluginInstance("BlockElements").allowedAttributes;
+		if (!this.allowedAttributes && this.getPluginInstance("BlockElements")) {
+			this.allowedAttributes = this.getPluginInstance("BlockElements").allowedAttributes;
 		}
 		if (!this.allowedAttributes) {
 			this.allowedAttributes = new Array("id", "title", "lang", "xml:lang", "dir", "class");
@@ -72,7 +72,7 @@
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "0.1",
+			version		: "1.0",
 			developer	: "Stanislas Rolland",
 			developerUrl	: "http://www.sjbr.ca/",
 			copyrightOwner	: "Stanislas Rolland",
@@ -101,21 +101,20 @@
 		/*
 		 * Registering the dropdown list
 		 */
-		if (this.buttonsConfiguration.language && this.buttonsConfiguration.language.languagesUrl) {
-				// Load the options into HTMLArea.languageOptions
-			var languagesData = this.getJavascriptFile(this.buttonsConfiguration.language.languagesUrl, "noEval");
-			if (languagesData) {
-				eval(languagesData);
+		var buttonId = 'Language';
+		if (this.buttonsConfiguration[buttonId.toLowerCase()] && this.buttonsConfiguration[buttonId.toLowerCase()].dataUrl) {
+				// Load the options var
+			var optionsData = this.getJavascriptFile(this.buttonsConfiguration[buttonId.toLowerCase()].dataUrl, "noEval");
+			if (optionsData) {
+				eval(optionsData);
 			}
 		}
-		var buttonId = "Language";
 		var dropDownConfiguration = {
 			id		: buttonId,
 			tooltip		: this.localize(buttonId + "-Tooltip"),
-			options		: (HTMLArea.languageOptions ? HTMLArea.languageOptions : null),
+			options		: options,
 			action		: "onChange",
-			refresh		: null,
-			context		: null
+			listWidth	: 200
 		};
 		this.registerDropDown(dropDownConfiguration);
 
@@ -136,16 +135,13 @@
 			// Add rules to the stylesheet for language mark highlighting
 			// Model: body.htmlarea-show-language-marks *[lang=en]:before { content: "en: "; }
 			// Works in IE8, but not in earlier versions of IE
-		var obj = this.getDropDownConfiguration("Language");
-		if ((typeof(obj) !== "undefined") && (typeof(this.editor._toolbarObjects[obj.id]) !== "undefined")) {
+		var select = this.getButton('Language');
+		if (select) {
 			var styleSheet = this.editor._doc.styleSheets[0];
-			var select = document.getElementById(this.editor._toolbarObjects[obj.id].elementId);
-			var options = select.options;
-			var rule, selector, style;
-			for (var i = options.length; --i >= 0;) {
-				selector = 'body.htmlarea-show-language-marks *[' + 'lang="' + options[i].value + '"]:before';
-				style = 'content: "' + options[i].value + ': ";';
-				rule = selector + ' { ' + style + ' }';
+			select.getStore().each(function (option) {
+				var selector = 'body.htmlarea-show-language-marks *[' + 'lang="' + option.get('value') + '"]:before';
+				var style = 'content: "' + option.get('value') + ': ";';
+				var rule = selector + ' { ' + style + ' }';
 				if (HTMLArea.is_gecko) {
 					try {
 						styleSheet.insertRule(rule, styleSheet.cssRules.length);
@@ -155,7 +151,8 @@
 				} else {
 					styleSheet.addRule(selector, style);
 				}
-			}
+				return true;
+			});
 		}
 	},
 
@@ -225,10 +222,8 @@
 	/*
 	 * This function gets called when some language was selected in the drop-down list
 	 */
-	onChange : function (editor, buttonId) {
-		var tbobj = this.editor._toolbarObjects[buttonId];
-		var language = document.getElementById(tbobj.elementId).value;
-		this.applyLanguageMark(language);
+	onChange : function (editor, combo, record, index) {
+		this.applyLanguageMark(combo.getValue());
 	},
 
 	/*
@@ -236,7 +231,7 @@
 	 */
 	applyLanguageMark : function (language) {
 		var selection = this.editor._getSelection();
-		var statusBarSelection = this.editor.getPluginInstance("StatusBar") ? this.editor.getPluginInstance("StatusBar").getSelection() : null;
+		var statusBarSelection = this.editor.statusBar ? this.editor.statusBar.getSelection() : null;
 		var range = this.editor._createRange(selection);
 		var parent = this.editor.getParentElement(selection, range);
 		var selectionEmpty = this.editor._selectionEmpty(selection);
@@ -391,94 +386,74 @@
 	/*
 	 * This function gets called when the toolbar is updated
 	 */
-	onUpdateToolbar : function () {
-		if (this.getEditorMode() === "wysiwyg" && this.editor.isEditable()) {
+	onUpdateToolbar: function (button, mode, selectionEmpty, ancestors, endPointsInSameBlock) {
+		if (mode === 'wysiwyg' && this.editor.isEditable()) {
 			var selection = this.editor._getSelection();
-			var statusBarSelection = this.editor.getPluginInstance("StatusBar") ? this.editor.getPluginInstance("StatusBar").getSelection() : null;
+			var statusBarSelection = this.editor.statusBar ? this.editor.statusBar.getSelection() : null;
 			var range = this.editor._createRange(selection);
 			var parent = this.editor.getParentElement(selection);
-				// Updating the direction buttons
-			var buttonList = this.buttonList, buttonId;
-			for (var i = 0, n = buttonList.length; i < n; ++i) {
-				buttonId = buttonList[i][0];
-				if (this.isButtonInToolbar(buttonId)) {
-					switch (buttonId) {
-						case "RightToLeft" :
-						case "LeftToRight" :
-							if (parent) {
-								var direction = (buttonId === "RightToLeft") ? "rtl" : "ltr";
-								this.editor._toolbarObjects[buttonId].state("active",(parent.dir == direction || parent.style.direction == direction));
-							}
-							break;
-						case "ShowLanguageMarks":
-							this.editor._toolbarObjects[buttonId].state("active", HTMLArea._hasClass(this.editor._doc.body, 'htmlarea-show-language-marks'));
-							break;
-						default	:
-							break;
+			switch (button.itemId) {
+				case 'RightToLeft':
+				case 'LeftToRight':
+					if (parent) {
+						var direction = (button.itemId === 'RightToLeft') ? 'rtl' : 'ltr';
+						button.setInactive(parent.dir != direction && parent.style.direction != direction);
 					}
-				}
-			}
-				// Updating the language drop-down
-			var fullNodeSelected = false;
-			var language = this.getLanguageAttribute(parent);
-			var selectionEmpty = this.editor._selectionEmpty(selection);
-			var endPointsInSameBlock = this.editor.endPointsInSameBlock();
-			if (!selectionEmpty) {
-				if (endPointsInSameBlock) {
-					var ancestors = this.editor.getAllAncestors();
-					for (var i = 0; i < ancestors.length; ++i) {
-						fullNodeSelected = (statusBarSelection === ancestors[i])
-							&& ((HTMLArea.is_gecko && ancestors[i].textContent === range.toString()) || (HTMLArea.is_ie && ((selection.type !== "Control" && ancestors[i].innerText === range.text) || (selection.type === "Control" && ancestors[i].innerText === range.item(0).text))));
-						if (fullNodeSelected) {
-							parent = ancestors[i];
-							break;
+					break;
+				case 'ShowLanguageMarks':
+					button.setInactive(!HTMLArea._hasClass(this.editor._doc.body, 'htmlarea-show-language-marks'));
+					break;
+				case 'Language':
+						// Updating the language drop-down
+					var fullNodeSelected = false;
+					var language = this.getLanguageAttribute(parent);
+					if (!selectionEmpty) {
+						if (endPointsInSameBlock) {
+							for (var i = 0; i < ancestors.length; ++i) {
+								fullNodeSelected = (statusBarSelection === ancestors[i])
+									&& ((HTMLArea.is_gecko && ancestors[i].textContent === range.toString()) || (HTMLArea.is_ie && ((selection.type !== "Control" && ancestors[i].innerText === range.text) || (selection.type === "Control" && ancestors[i].innerText === range.item(0).text))));
+								if (fullNodeSelected) {
+									parent = ancestors[i];
+									break;
+								}
+							}
+								// Working around bug in Safari selectNodeContents
+							if (!fullNodeSelected && HTMLArea.is_safari && statusBarSelection && statusBarSelection.textContent === range.toString()) {
+								fullNodeSelected = true;
+								parent = statusBarSelection;
+							}
+							language = this.getLanguageAttribute(parent);
+						} else {
+							language = this.getLanguageAttributeFromBlockElements();
 						}
 					}
-						// Working around bug in Safari selectNodeContents
-					if (!fullNodeSelected && HTMLArea.is_safari && statusBarSelection && statusBarSelection.textContent === range.toString()) {
-						fullNodeSelected = true;
-						parent = statusBarSelection;
-					}
-					language = this.getLanguageAttribute(parent);
-				} else {
-					language = this.getLanguageAttributeFromBlockElements();
-				}
+					this.updateValue(button, language, selectionEmpty, fullNodeSelected, endPointsInSameBlock);
+					break;
+				default:
+					break;
 			}
-			var obj = this.getDropDownConfiguration("Language");
-			if ((typeof(obj) !== "undefined") && (typeof(this.editor._toolbarObjects[obj.id]) !== "undefined")) {
-				this.updateValue(obj, language, selectionEmpty, fullNodeSelected, endPointsInSameBlock);
-			}
 		}
 	},
 
 	/*
 	* This function updates the language drop-down list
 	*/
-	updateValue : function (obj, language, selectionEmpty, fullNodeSelected, endPointsInSameBlock) {
-		var select = document.getElementById(this.editor._toolbarObjects[obj.id]["elementId"]);
-		var options = select.options;
-		for (var i = options.length; --i >= 0;) {
-			options[i].selected = false;
+	updateValue : function (select, language, selectionEmpty, fullNodeSelected, endPointsInSameBlock) {
+		var store = select.getStore();
+		store.removeAt(0);
+		if ((store.findExact('value', language) != -1) && (selectionEmpty || fullNodeSelected || !endPointsInSameBlock)) {
+			select.setValue(language);
+			store.insert(0, new store.recordType({
+				text: this.localize('Remove language mark'),
+				value: 'none'
+			}));
+		} else {
+			store.insert(0, new store.recordType({
+				text: this.localize('No language mark'),
+				value: 'none'
+			}));
+			select.setValue('none');
 		}
-		select.selectedIndex = 0;
-		options[0].selected = true;
-		select.options[0].text = this.localize("No language mark");
-		if (language != "none") {
-			for (i = options.length; --i >= 0;) {
-				if (language == options[i].value) {
-					if (selectionEmpty || fullNodeSelected || !endPointsInSameBlock) {
-						options[i].selected = true;
-						select.selectedIndex = i;
-						select.options[0].text = this.localize("Remove language mark");
-					}
-					break;
-				}
-			}
-		}
-		select.disabled = !(options.length>1) || (selectionEmpty && this.editor.getParentElement().nodeName.toLowerCase() === "body");
-		select.className = "";
-		if (select.disabled) {
-			select.className = "buttonDisabled";
-		}
+		select.setDisabled(!(store.getCount()>1) || (selectionEmpty && this.editor.getParentElement().nodeName.toLowerCase() === 'body'));
 	}
 });
